jQuery(document).ready(function() {

	jQuery('.theme-gallery').each(function(){
        var token = jQuery(this).attr('data-token');
        setThemeGalleryMargins(jQuery(this), token);
	});

});

jQuery( window ).on('resize', function(){
	jQuery('.theme-gallery').each(function(){
        var token = jQuery(this).attr('data-token');
        jQuery(this).find('.clearfix').remove();
        jQuery(this).find('.theme-gallery-item').each(function(){
            jQuery(this).removeClass( jQuery(this).attr('data-class') );
            jQuery(this).removeAttr('data-class');
            jQuery(this).css('margin-right', '0px;');    
        });
        setThemeGalleryMargins(jQuery(this), token);
	});
});


function setThemeGalleryMargins(gallery, token) {

    var line = 1;
    var w = gallery.width();
    var line_width = 0;
    var cnt = 0;
    var margin = 0;
    
    gallery.find('.theme-gallery-item').each(function(){
        // var img_w = jQuery(this).width();
        var img_w = jQuery(this).find('.theme-gallery-image').outerWidth();
        jQuery(this).find('.theme-gallery-title').width(img_w);
        if ((line_width + jQuery(this).width()) < w) {
            line_width = line_width + img_w;
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt++; 
        } else {
            cnt--;
            margin = Math.floor((w - line_width) / cnt);
            jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
            jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
            line++;
            jQuery('<div class="clearfix" style="clear:both;"></div>').insertBefore(this);
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt = 1;
            line_width = img_w;
        }                
    });    
    cnt--;
    var margin2 = Math.floor((w - line_width) / cnt);
    
    if (margin2 < margin && cnt < 2) { margin = margin2; }
    if (margin == 0) { margin = 12; }
    jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
    jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
}

function theme_gallery_get_page(id, item) {
    var token = item.closest('.theme-gallery-pagination').attr('data-token');
    var actual = item.closest('.theme-gallery-pagination').attr('data-actual');
    
    if (actual != id) {
      jQuery('#'+token+'_theme_gallery_pagination_item_'+actual).removeClass('current');
      
      theme_gallery_get_images_page(token, id); 
      
      item.closest('.theme-gallery-pagination').attr('data-actual', id);
      jQuery('#'+token+'_theme_gallery_pagination_item_'+id).addClass('current');  
    } 
}

function theme_gallery_get_images_page(token, page) {

    var images = eval('images_'+token),
        count  = Number(eval('count_'+token));
    
    var all = images.length - 1;
    var i;
    
    var start = Number((page-1) * count);
    var end   = Number(start + (count-1));
    if (end > all) { end = all; } 

    var html = '';    
    for (i = start; i <= end; i++) {
        html += theme_gallery_add_image(images[i], token);
    } 
    html += "\t" + '<div style="clear:both"></div>' + "\r\n";
    
    jQuery('#theme_gallery_'+token).html(html);
    setThemeGalleryMargins( jQuery('#theme_gallery_'+token), token);
}

function theme_gallery_add_image(image, token) {
    html = "\t" + '<div class="theme-gallery-item">' + "\r\n";
    if (eval('link_'+token) != 'none') {
        html += "\t\t" + '<a data-fancybox="gallery_'+token+'" href="'+image['image'][0]+'" data-caption="'+image['caption']+'"  title="'+image['caption']+'">' + "\r\n" + "\t";
    }
    html += "\t\t\t" + '<img class="theme-gallery-image" src="'+image['thumb'][0]+'" style="width:'+image['thumb'][1]+'px;height:'+image['thumb'][2]+'px;" alt="'+image['caption']+'" />' + "\r\n" +
            "\t\t\t" + '<div class="theme-gallery-title">'+image['caption']+'</div>' + "\r\n";
    if (eval('link_'+token) != 'none') {
        html += "\t\t" + '</a>' + "\r\n";
    }
    html += "\t" + '</div>';
    return html;    
}


function dovi_theme_gallery_get_page(id, item) {
    var token = item.parent('.dovi-theme-gallery-pagination').attr('data-token');
    var actual = item.parent('.dovi-theme-gallery-pagination').attr('data-actual');
    
    if (actual != id) {
      jQuery('#'+token+'_dovi-theme-gallery-pagination_item_'+actual).removeClass('actual');
      
      dovi_theme_gallery_showImages(token, id); 
      
      item.parent('.dovi-theme-gallery-pagination').attr('data-actual', id);
      jQuery('#'+token+'_dovi-theme-gallery-pagination_item_'+id).addClass('actual');  
    } 
}

function theme_gallery_showImage(image, token) {
    var html = '';
    
    html = "\t" + '<div class="dovi-theme-gallery-item">' + "\r\n";
    if (eval('link_'+token) != 'none') {
        html += "\t\t" + '<a data-fancybox="gallery_'+token+'" href="'+image['image'][0]+'" data-caption="'+image['caption']+'"  title="'+image['caption']+'">' + "\r\n" + "\t";
    }

    html += "\t\t" + '<div class="dovi-theme-gallery-image">' + "\r\n" + 
            "\t\t\t" + '<div style="width:'+image['thumb'][1]+'px;height:'+image['thumb'][2]+'px;">' + "\r\n" +
            "\t\t\t\t" + '<img src="'+image['thumb'][0]+'" style="width:'+image['thumb'][1]+'px;height:'+image['thumb'][2]+'px;" alt="'+image['caption']+'" />' + "\r\n" +
            "\t\t\t" + '</div>' + "\r\n" +
            "\t\t" + '</div>' + "\r\n";

    if (eval('link_'+token) != 'none') {
        html += "\t\t" + '</a>' + "\r\n";
    }
    
    html += "\t" + '</div>';
    
    return html;    
}

function dovi_theme_gallery_showImages(token, page) {
    
    var images = eval('images_'+token),
        count  = Number(eval('count_'+token));
    
    var all = images.length - 1;
    var i;
    
    var start = Number((page-1) * count);
    var end   = Number(start + (count-1));
    if (end > all) { end = all; } 
    
    jQuery('#dovi_theme_gallery_'+token).html('');

    var html = '';    
    for (i = start; i <= end; i++) {
        html = dovi_theme_gallery_showImage(images[i], token);
        jQuery('#dovi_theme_gallery_'+token).append(html);  
    } 
    dovi_theme_gallery_setFullWidth();
}


