<?php
/*
Plugin Name: Dovi WPGallery
Plugin URI:  http://wpdemo.dovi42.hu/wordpress-galeria-felulirasa/
Description: Override WP gallery
Version:     2.07
Author:      Dovi
Author URI:  http://dovi42.hu
License:     GNU General Public License (GPL)
License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
Text Domain: dovi-wpgallery
Generator:   WP Generator - http://dovi42.hu - 2019-11-22 14:30:44
*/

if ( !defined( 'ABSPATH' ) ) exit;

function dovi_wpgallery_694_update()
{
    require_once ( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'autoupdate.php' ); 
	
    // set auto-update params
	$plugin_current_version = '2.07'; // Current version
	$plugin_remote_path     = 'http://update.dovi42.hu/dovi-wpgallery/update.php';  
	$plugin_slug            = plugin_basename(__FILE__);
	$license_user           = get_site_url();
	$license_key            = '<optional license key>';

	// only perform Auto-Update call if a license_user and license_key is given
	if ( $license_user && $license_key && $plugin_remote_path )
	{
		new dovi_wpgallery_694_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'dovi_wpgallery_694_update');


//Init hook
add_action('init', 'override_wp_original_694_gallery');
 
//Override function
function override_wp_original_694_gallery()
{
    remove_shortcode('gallery');
    add_shortcode('gallery', 'dovi_wpgallery_694_shortcode');
}

function dovi_wpgallery_694_load_fancybox() { 
    $options = dovi_wpgallery_694_get_options('dovi_wpgallery_options');
    if ($options['load_clearbox'] == 1) {
        wp_register_style( 'dovi-fancybox-css', plugins_url( 'dovi-wpgallery/assets/css/fancybox.min.css' ) );
    	wp_enqueue_style(  'dovi-fancybox-css' );
        wp_register_script('dovi-wpgallery-fancybox-js', plugins_url( 'dovi-wpgallery/assets/js/fancybox/fancybox.min.js'), array('jquery'), false, true);
        wp_enqueue_script( 'dovi-wpgallery-fancybox-js');    
    }
}
add_action( 'wp_enqueue_scripts', 'dovi_wpgallery_694_load_fancybox', 9999 );


function dovi_wpgallery_694_styles_and_scripts_to_frontend($options, $images)
{
    global $post;

    define('DOVI_WPGALLERY_694', 1);

	wp_register_script('wp-gallery-js', plugins_url( 'dovi-wpgallery/assets/js/wp-gallery.min.js' ), array('jquery'), false, true);
    wp_enqueue_script( 'wp-gallery-js');
    wp_localize_script('wp-gallery-js', 'count_'.$options['token'], (string) $options['count']);
    wp_localize_script('wp-gallery-js', 'link_'.$options['token'], $options['link']);
    wp_localize_script('wp-gallery-js', 'title_'.$options['token'], $post->post_title);
    wp_localize_script('wp-gallery-js', 'images_'.$options['token'], $images);
    
    $options = dovi_wpgallery_694_get_options('dovi_wpgallery_options');

    if ($options['load_css'] == 1) {
        wp_register_style( 'wp-gallery', plugins_url( 'dovi-wpgallery/assets/css/wp-gallery.min.css' ) );
    	wp_enqueue_style( 'wp-gallery' );
    }
}

function dovi_wpgallery_694_styles_and_scripts_to_frontend_variables($options, $images)
{
    global $post;

    wp_localize_script('wp-gallery-js', 'count_'.$options['token'], (string) $options['count']);
    wp_localize_script('wp-gallery-js', 'link_'.$options['token'], $options['link']);
    wp_localize_script('wp-gallery-js', 'title_'.$options['token'], $post->post_title);
    wp_localize_script('wp-gallery-js', 'images_'.$options['token'], $images);
    
    
}


//Custom gallery shortcode
function dovi_wpgallery_694_shortcode($args) {

    global $post; 

    $options = array(
            'ids'     => '',
            'columns' => '3',
			'size'    => 'thumbnail',
            'orderby' => '',
            'link'    => 'file', //file | link | <empty string> (for linking to attachment page)
            'count'   => '10'  
        );
    foreach ($args as $key => $value) {
        $options[$key] = $value;
    }

    $list = preg_replace('/[^0-9,]+/', '', $options['ids']);
    if (!empty($list)) {

        $list = explode(',', $list);
        if (empty($options['orderby']) and ($options['orderby'] == 'rand')) {
            shuffle($list);
        }

        $images = array();
        
        foreach ($list as $item) {
            $attachment = get_post( $item );
            $caption = $attachment->post_excerpt;
            
            $images[] = array(
                    'thumb'   => wp_get_attachment_image_src($item, $options['size']),
                    'image'   => wp_get_attachment_image_src($item, 'large'),
                    'caption' => $caption
                );
        }
        
    }    

    if (count($images) > 0) {

        if (count($images) < $options['count']) {
            $options['count'] = count($images);
        }

        
        $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
        $token = '';
        for ($i = 0; $i <= 9; $i++) {
        	$token .= substr($chars, rand(0, strlen($chars)-1), 1);
        }                
        
        $options['token'] = $token;

        if (!defined('DOVI_WPGALLERY_694')) {
            // A globális beállítások átadódnak a script-ek meghívásához
            // Global settings are passed to invite scripts
            dovi_wpgallery_694_styles_and_scripts_to_frontend($options, $images);
        } else {
            dovi_wpgallery_694_styles_and_scripts_to_frontend_variables($options, $images);
        }
 
        $html = '<div id="dovi_wpgallery_'.$options['token'].'" class="dovi-wpgallery" data-token="'.$options['token'].'">' . "\r\n";

        // foreach ($images as $image) {
        for ($i = 1; $i <= $options['count']; $i++) {
            
            $image = $images[$i-1];	
        
            $html = "\r\n" .
                    '<div id="theme_gallery_'.$options['token'].'" class="theme-gallery" data-token="'.$options['token'].'">' . "\r\n"; 
            
            for ($i = 1; $i <= $options['count']; $i++) {
            
                $image = $images[$i-1];            
                $html .= "\t" . '<div class="theme-gallery-item">' . "\r\n" .
                         "\t\t" . '<a data-fancybox="gallery_'.$options['token'].'" href="'.$image['image'][0].'" data-caption="'.$image['caption'].'" title="'.$image['caption'].'">' . "\r\n" .                     
                         "\t\t\t" . '<img class="theme-gallery-image" src="'.$image['thumb'][0].'" style="width:'.$image['thumb'][1].'px;height:'.$image['thumb'][2].'px;" alt="'.$image['caption'].'" />' . "\r\n" .
                         "\t\t\t" . '<div class="theme-gallery-title">'.$image['caption'].'</div>' . "\r\n" .
                         "\t\t" . '</a>' . "\r\n" .
                         "\t" . '</div>' . "\r\n";
    
            }    
            $html .= "\t" . '<div style="clear:both"></div>' . "\r\n" .
                     '</div>' . "\r\n" .
                     '<div style="clear:both;"></div>' . "\r\n";
        }
        
        if (count($images) > $options['count']) {
            
            $pages = ceil(count($images) / $options['count']);
            
            $html .= '<ul class="theme-gallery-pagination" data-token="'.$options['token'].'"  data-actual="1">' . "\r\n";
            for ($i = 1; $i <= $pages; $i++) {
                if ($i == 1) {
                    $current = 'current';
                } else {
                    $current = '';
                }
                $html .= '<li class="theme-gallery-page-item"><span id="'.$options['token'].'_theme_gallery_pagination_item_'.$i.'" class="theme-gallery-page-link '.$current.'" onclick="theme_gallery_get_page(\''.$i.'\', jQuery(this));">'.$i.'</span></li>' . "\r\n";
            }
            $html .= '</ul>' . "\r\n" . 
                     '<div style="clear:both;"></div>' . "\r\n";
        
        }
    }

    return $html;
    
}

if ( is_admin() ){ 
    include( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'dovi-wpgallery-setup.php' );
    $my_settings_page = new dovi_wpgallery_694_settings();

    function dovi_wpgallery_694_load_textdomain() {
        load_plugin_textdomain( 'dovi-wpgallery', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
    }
    add_action( 'plugins_loaded', 'dovi_wpgallery_694_load_textdomain' );

}

function dovi_wpgallery_694_get_options($id) { 
    if ($id != "") : 

        // Set default option values
        $defaults = array(
             'load_clearbox' => 0,
             'load_css'      => 1,
            );

        // Get the set plugin option values
        $options = get_option($id);

        foreach ($defaults as $key => $value) {
            // If not set then set the default 
            if (!isset($options[$key])) {
                $options[$key] = $defaults[$key];
            }
        }
        return $options;
    else:
        return array();
    endif;
}

function dovi_wpgallery_694_additional_gallery_settings() {
  ?>

    <script type="text/html" id="tmpl-custom-gallery-setting">
        <span class="setting">
            <label class="name" for="gallery-setting-count" style="max-width:120px;"><?php echo __('Count per Page', 'dovi-wpgallery');?></label>
            <input type="text" data-setting="count" name="count" id="gallery-setting-count" />
        </span>
    </script>

    <script type="text/javascript">
        jQuery( document ).ready( function() {
            _.extend( wp.media.gallery.defaults, {
                count: 10,
                link: 'file',
                columns: 4
            } );

            wp.media.view.Settings.Gallery = wp.media.view.Settings.Gallery.extend({
                template: function( view ) {
                    return wp.media.template( 'gallery-settings' )( view )
                         + wp.media.template( 'custom-gallery-setting' )( view );
                }
            });

            wp.media.view.Modal.prototype.on( "open", function() {
                jQuery('#gallery-settings-columns').closest('.setting').css('display', 'none');
            });
        } );
    </script>

  <?php
}
add_action( 'print_media_templates', 'dovi_wpgallery_694_additional_gallery_settings' );

// Add settings link to plugins page 
function dovi_wpgallery_694_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=dovi-wpgallery-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$plugin", 'dovi_wpgallery_694_add_settings_link' );


